/* Copyright (c) 1997-2010
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: liftings.h 10090 2011-03-24 15:40:56Z joswig $
*/

#ifndef POLYMAKE_TROPICAL_LIFTINGS_H
#define POLYMAKE_TROPICAL_LIFTINGS_H

#include "polymake/Polynomial.h"
#include "polymake/Rational.h"
#include "polymake/Matrix.h"
#include "polymake/Vector.h"

namespace polymake { namespace tropical {

typedef std::pair<Matrix<int>, Vector<Rational> > TropicalPolynomial;

typedef Ring<UniPolynomial<Rational,Rational>,int> PuiseuxRing;

typedef Polynomial<UniPolynomial<Rational,Rational>,int> PuiseuxPolynomial;

PuiseuxPolynomial pointlift(const Vector<Rational> &p, const PuiseuxRing& r);

TropicalPolynomial tropicalize(const PuiseuxPolynomial &p);

} }

#endif // POLYMAKE_TROPICAL_LIFTINGS_H

// Local Variables:
// mode:C++
// c-basic-offset:3
// indent-tabs-mode:nil
// End:
